
#include <errno.h>
#include <stdio.h>
#include <netinet/in.h>
#include <sys/socket.h>

void run(const char *ip)
{
  struct in_addr netorder_addr;
  uint32_t       hostorder_addr;

  if (inet_pton(AF_INET, ip, &netorder_addr) <= 0) {
    fprintf(stderr, "inet_pton(%s): errno=%d: %s\n",
	    ip, errno, strerror(errno));
    exit(1);
  }

  printf("netorder: %s: uint32_t = %u\n", ip, netorder_addr.s_addr);
  printf("netorder: %s: ((uint8_t *) &net_ip)[0] = %u\n", ip, ((uint8_t *) &netorder_addr)[0]);
  printf("netorder: %s: ((uint8_t *) &net_ip)[1] = %u\n", ip, ((uint8_t *) &netorder_addr)[1]);
  printf("netorder: %s: ((uint8_t *) &net_ip)[2] = %u\n", ip, ((uint8_t *) &netorder_addr)[2]);
  printf("netorder: %s: ((uint8_t *) &net_ip)[3] = %u\n", ip, ((uint8_t *) &netorder_addr)[3]);

  hostorder_addr = ntohl(netorder_addr.s_addr);

  printf("hostorder: %s: uint32_t = %u\n", ip, hostorder_addr);
  printf("hostorder: %s: ((uint8_t *) &host_ip)[0] = %u\n", ip, ((uint8_t *) &hostorder_addr)[0]);
  printf("hostorder: %s: ((uint8_t *) &host_ip)[1] = %u\n", ip, ((uint8_t *) &hostorder_addr)[1]);
  printf("hostorder: %s: ((uint8_t *) &host_ip)[2] = %u\n", ip, ((uint8_t *) &hostorder_addr)[2]);
  printf("hostorder: %s: ((uint8_t *) &host_ip)[3] = %u\n", ip, ((uint8_t *) &hostorder_addr)[3]);
}

int main(int argc, const char *argv[])
{
  if (argc != 2) {
    fprintf(stderr, "usage: %s ip\n", argv[0]);
    exit(1);
  }

  run(argv[1]);

  exit(0);
}
